req {shiny} | R Documentation

## Check for required values

### Description

Ensure that values are available ("truthy"–see Details) before proceeding with a calculation or action. If any of the given values is not truthy, the operation is stopped by raising a "silent" exception (not logged by Shiny, nor displayed in the Shiny app's UI).

### Usage

    req(...)

### Arguments

`...` | Values to check for truthiness.

### Details

The `req` function was designed to be used in one of two ways. The first is to call it like a statement (ignoring its return value) before attempting operations using the required values:

    rv <- reactiveValues(state = FALSE)
    r <- reactive({
      req(input$a, input$b, rv$state)
      # Code that uses input$a, input$b, and/or rv$state...
    })

In this example, if `r()` is called and any of `input$a`, `input$b`, and `rv$state` are `NULL`, `FALSE`, `""`, etc., then the `req` call will trigger an error that propagates all the way up to whatever render block or observer is executing.

The second is to use it to wrap an expression that must be truthy:

    output$plot <- renderPlot({
      if (req(input$plotType) == "histogram") {
        hist(dataset())
      } else if (input$plotType == "scatter") {
        qplot(dataset(), aes(x = x, y = y))
      }
    })

In this example, `req(input$plotType)` first checks that `input$plotType` is truthy, and if so, returns it. This is a convenient way to check for a value "inline" with its first use.

Truthy and falsy values

The terms "truthy" and "falsy" generally indicate whether a value, when coerced to a `logical`, is `TRUE` or `FALSE`. We use the term a little loosely here; our usage tries to match the intuitive notions of "Is this value missing or available?", or "Has the user provided an answer?", or in the case of action buttons, "Has the button been clicked?".

For example, a `textInput` that has not been filled out by the user has a value of `""`, so that is considered a falsy value.

To be precise, `req` considers a value truthy unless it is one of:

- `FALSE`

- `NULL`

- `""`

- An empty atomic vector

- An atomic vector that contains only missing values

- A logical vector that contains all `FALSE` or missing values

- An object of class `"try-error"`

- A value that represents an unclicked `actionButton`

Note in particular that the value `0` is considered truthy, even though `as.logical(0)` is `FALSE`.

If the built-in rules for truthiness do not match your requirements, you can always work around them. Since `FALSE` is falsy, you can simply provide the results of your own checks to `req`:

`req(input$a != 0)`

### Value

The first value that was passed in.

[Package shiny version 0.13.2 Index]